﻿Public Class AnimationFrame
    Private m_Frame(4, 4) As Boolean

    Public Property GetPixel(x As Integer, y As Integer) As Boolean
        Get
            Return m_Frame(x, y)
        End Get
        Set(value As Boolean)
            m_Frame(x, y) = value
        End Set
    End Property

    Public Sub New()
        For x As Integer = 0 To 4
            For y As Integer = 0 To 4
                m_Frame(x, y) = False
            Next
        Next
    End Sub

    Public Sub TogglePixel(x As Integer, y As Integer)
        m_Frame(x, y) = Not m_Frame(x, y)
    End Sub

    Public Sub UpdateFrameFromPicBoxArray(ByRef pics(,) As PictureBox)
        For x As Integer = 0 To 4
            For y As Integer = 0 To 4
                If pics(x, y).BackColor = Color.Red Then
                    m_Frame(x, y) = True
                Else
                    m_Frame(x, y) = False
                End If
            Next
        Next
    End Sub
    Public Sub UpdatePicBoxArrayFromFrame(ByRef pics(,) As PictureBox)
        For x As Integer = 0 To 4
            For y As Integer = 0 To 4
                If m_Frame(x, y) Then
                    pics(x, y).BackColor = Color.Red
                Else
                    pics(x, y).BackColor = Color.White
                End If
            Next
        Next
    End Sub

    Public Sub UpdateFrameFromCSVString(csv As String)
        Dim s() As String = csv.Split(",")
        Dim current As Integer = 0
        For y As Integer = 0 To 4
            For x As Integer = 0 To 4
                If Int(s(current)) = 9 Then
                    m_Frame(x, y) = True
                Else
                    m_Frame(x, y) = False
                End If
                current += 1
            Next
        Next
    End Sub

    Public Function FrameToBitmap() As Bitmap
        Dim bmp As New Bitmap(26, 26)
        Dim g As Graphics = Graphics.FromImage(bmp)
        For y As Integer = 0 To 4
            For x As Integer = 0 To 4
                If m_Frame(x, y) Then
                    g.FillRectangle(Brushes.Red, x * 5, y * 5, 5, 5)
                End If
                g.DrawRectangle(Pens.DarkGray, x * 5, y * 5, 5, 5)
            Next
        Next


        Return bmp
    End Function
    Public Function FrameToBitmapLarge() As Bitmap
        Dim bmp As New Bitmap(400, 400)
        Dim g As Graphics = Graphics.FromImage(bmp)
        For y As Integer = 0 To 4
            For x As Integer = 0 To 4
                If m_Frame(x, y) Then
                    g.FillRectangle(Brushes.Red, x * 80, y * 80, 80, 80)
                End If
                g.DrawRectangle(Pens.DarkGray, x * 80, y * 80, 80, 80)
            Next
        Next


        Return bmp
    End Function

    Public Function FrameToString() As String
        Dim strO As String = "'"
        For y As Integer = 0 To 4
            For x As Integer = 0 To 4
                If m_Frame(x, y) Then
                    strO &= "9"
                Else
                    strO &= "0"
                End If
                If x = 4 Then strO &= ":"
            Next
        Next
        strO &= "'"
        Return strO
    End Function

    Public Function FrameToCSV() As String
        Dim strO As String = ""
        For y As Integer = 0 To 4
            For x As Integer = 0 To 4
                If m_Frame(x, y) Then
                    strO &= "9"
                Else
                    strO &= "0"
                End If
                If Not (x = 4 And y = 4) Then strO &= ","
            Next
        Next

        Return strO
    End Function
End Class
