﻿Imports System.IO
Public Class Form1
    Dim picPixel(4, 4) As PictureBox
    Public frames As New List(Of AnimationFrame)()
    Dim current As Integer = 0


    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim f As AnimationFrame = New AnimationFrame()
        frames.Add(f)
        For y As Integer = 0 To 4
            For x As Integer = 0 To 4
                picPixel(x, y) = New PictureBox()
                With picPixel(x, y)
                    .Size = New Size(50, 50)
                    .BorderStyle = BorderStyle.FixedSingle
                    .BackColor = Color.White
                    .Location = New Point(10 + (x * 55), 10 + (y * 55))
                    .ContextMenuStrip = conStrip
                End With
                AddHandler picPixel(x, y).Click, New EventHandler(AddressOf PictureBox_Click)
                Me.Controls.Add(picPixel(x, y))
            Next
        Next
        frames.Item(current).UpdateFrameFromPicBoxArray(picPixel)
        lstFrames.SelectedIndex = 0
        UpdateList()
    End Sub
    Sub PictureBox_Click(sender As Object, e As MouseEventArgs)
        Dim p As PictureBox = sender
        If p.BackColor = Color.White Then
            p.BackColor = Color.Red
        Else
            p.BackColor = Color.White
        End If
        UpdateList()
    End Sub
    Sub UpdateList()
        lstFrames.BeginUpdate()
        lstFrames.Items.Clear()
        For i As Integer = 0 To frames.Count - 1
            lstFrames.Items.Add("Frame " & Trim(Str(i)))
        Next
        lstFrames.SelectedIndex = current
        lstFrames.EndUpdate()
        lstFrames.Focus()
    End Sub
    Private Sub lstFrames_SelectedIndexChanged(sender As Object, e As EventArgs) Handles lstFrames.SelectedIndexChanged
        If lstFrames.SelectedIndex = -1 Then Exit Sub
        frames.Item(current).UpdateFrameFromPicBoxArray(picPixel)
        current = lstFrames.SelectedIndex
        frames.Item(current).UpdatePicBoxArrayFromFrame(picPixel)
    End Sub

    Private Sub lstFrames_DrawItem(sender As Object, e As DrawItemEventArgs) Handles lstFrames.DrawItem
        Dim g As Graphics = e.Graphics
        e.DrawBackground()
        If e.Index >= 0 Then
            g.DrawImage(frames(e.Index).FrameToBitmap(), e.Bounds.X, e.Bounds.Y)
            g.DrawString("Frame " & Trim(Str(e.Index)), New Font("Courier New", 16, FontStyle.Bold, GraphicsUnit.Pixel), Brushes.Black, e.Bounds.X + 50, e.Bounds.Y + 2)
        End If
        e.DrawFocusRectangle()
        g.Dispose()
    End Sub

    Private Sub btnCopy_Click(sender As Object, e As EventArgs) Handles btnCopy.Click
        frames.Item(current).UpdateFrameFromPicBoxArray(picPixel)
        Dim f As New AnimationFrame
        frames.Insert(current, f)
        frames.Item(current).UpdateFrameFromPicBoxArray(picPixel)
        UpdateList()
    End Sub

    Private Sub btnUp_Click(sender As Object, e As EventArgs) Handles btnUp.Click
        For y As Integer = 0 To 3
            For x As Integer = 0 To 4
                picPixel(x, y).BackColor = picPixel(x, y + 1).BackColor
            Next
        Next
        For x As Integer = 0 To 4
            picPixel(x, 4).BackColor = Color.White
        Next
        frames(current).UpdateFrameFromPicBoxArray(picPixel)
        UpdateList()
    End Sub

    Private Sub btnDown_Click(sender As Object, e As EventArgs) Handles btnDown.Click
        For y As Integer = 4 To 1 Step -1
            For x As Integer = 0 To 4
                picPixel(x, y).BackColor = picPixel(x, y - 1).BackColor
            Next
        Next
        For x As Integer = 0 To 4
            picPixel(x, 0).BackColor = Color.White
        Next
        UpdateList()
        frames(current).UpdateFrameFromPicBoxArray(picPixel)
    End Sub

    Private Sub btnLeft_Click(sender As Object, e As EventArgs) Handles btnLeft.Click
        For x As Integer = 0 To 3
            For y As Integer = 0 To 4
                picPixel(x, y).BackColor = picPixel(x + 1, y).BackColor
            Next
        Next
        For y As Integer = 0 To 4
            picPixel(4, y).BackColor = Color.White
        Next
        frames(current).UpdateFrameFromPicBoxArray(picPixel)
        UpdateList()
    End Sub

    Private Sub btnRight_Click(sender As Object, e As EventArgs) Handles btnRight.Click
        For x As Integer = 4 To 1 Step -1
            For y As Integer = 0 To 4
                picPixel(x, y).BackColor = picPixel(x - 1, y).BackColor
            Next
        Next
        For y As Integer = 0 To 4
            picPixel(0, y).BackColor = Color.White
        Next
        frames(current).UpdateFrameFromPicBoxArray(picPixel)
        UpdateList()
    End Sub

    Private Sub btnClear_Click(sender As Object, e As EventArgs) Handles btnClear.Click
        For y As Integer = 0 To 4
            For x As Integer = 0 To 4
                picPixel(x, y).BackColor = Color.White
            Next
        Next
        frames(current).UpdateFrameFromPicBoxArray(picPixel)
        UpdateList()
    End Sub

    Private Sub btnMoveUp_Click(sender As Object, e As EventArgs) Handles btnMoveUp.Click
        If lstFrames.SelectedIndex < 1 Then
            Exit Sub
        Else
            frames(current).UpdateFrameFromPicBoxArray(picPixel)
            Dim newframes(frames.Count - 1) As AnimationFrame
            newframes = frames.ToArray()

            Dim t As Integer = lstFrames.SelectedIndex
            current = t - 1
            Dim f As AnimationFrame = newframes(t - 1)
            newframes(t - 1) = newframes(t)
            newframes(t) = f
            frames.Clear()
            frames.AddRange(newframes)
            UpdateList()

            lstFrames.SelectedIndex = current
            lstFrames.Focus()
        End If
    End Sub

    Private Sub btnMoveDown_Click(sender As Object, e As EventArgs) Handles btnMoveDown.Click
        If lstFrames.SelectedIndex < 0 Or lstFrames.SelectedIndex > lstFrames.Items.Count - 2 Or lstFrames.Items.Count = 1 Then
            Exit Sub
        Else
            frames(current).UpdateFrameFromPicBoxArray(picPixel)
            Dim newframes(frames.Count - 1) As AnimationFrame
            newframes = frames.ToArray()

            Dim t As Integer = lstFrames.SelectedIndex
            current = t + 1
            Dim f As AnimationFrame = newframes(t + 1)
            newframes(t + 1) = newframes(t)
            newframes(t) = f
            frames.Clear()
            frames.AddRange(newframes)
            UpdateList()

            lstFrames.SelectedIndex = current
            lstFrames.Focus()
        End If
    End Sub

    Private Sub btnRemove_Click(sender As Object, e As EventArgs) Handles btnRemove.Click
        If lstFrames.SelectedIndex < 0 Or lstFrames.Items.Count = 1 Then
            Exit Sub
        Else
            frames.RemoveAt(current)
            If current > frames.Count - 1 Then
                current = frames.Count - 1
            End If
            frames(current).UpdatePicBoxArrayFromFrame(picPixel)
            UpdateList()
            lstFrames.SelectedIndex = current
            lstFrames.Focus()
        End If
    End Sub
    Private Sub btnInsertBlank_Click(sender As Object, e As EventArgs) Handles btnInsertBlank.Click
        frames.Item(current).UpdateFrameFromPicBoxArray(picPixel)
        Dim f As New AnimationFrame
        frames.Insert(current, f)
        frames.Item(current).UpdatePicBoxArrayFromFrame(picPixel)
        UpdateList()
    End Sub

    Private Sub btnInvert_Click(sender As Object, e As EventArgs) Handles btnInvert.Click
        For x As Integer = 0 To 4
            For y As Integer = 0 To 4
                If picPixel(x, y).BackColor = Color.White Then
                    picPixel(x, y).BackColor = Color.Red
                Else
                    picPixel(x, y).BackColor = Color.White
                End If
            Next
        Next

        frames(current).UpdateFrameFromPicBoxArray(picPixel)
        UpdateList()
        lstFrames.SelectedIndex = current
        lstFrames.Focus()
    End Sub

    Private Sub mnuRowOn_Click(sender As Object, e As EventArgs) Handles mnuRowOn.Click
        Dim mnuItem As ToolStripMenuItem = sender
        Dim cMenu As ContextMenuStrip = mnuItem.Owner
        Dim thisPic As PictureBox = cMenu.SourceControl
        Dim row As Integer = (thisPic.Location.Y - 10) / 55
        For x As Integer = 0 To 4
            picPixel(x, row).BackColor = Color.Red
        Next
        frames(current).UpdateFrameFromPicBoxArray(picPixel)
        UpdateList()
        lstFrames.SelectedIndex = current
        lstFrames.Focus()
    End Sub

    Private Sub mnuRowOff_Click(sender As Object, e As EventArgs) Handles mnuRowOff.Click
        Dim mnuItem As ToolStripMenuItem = sender
        Dim cMenu As ContextMenuStrip = mnuItem.Owner
        Dim thisPic As PictureBox = cMenu.SourceControl
        Dim row As Integer = (thisPic.Location.Y - 10) / 55
        For x As Integer = 0 To 4
            picPixel(x, row).BackColor = Color.White
        Next
        frames(current).UpdateFrameFromPicBoxArray(picPixel)
        UpdateList()
        lstFrames.SelectedIndex = current
        lstFrames.Focus()
    End Sub

    Private Sub mnuColumnOn_Click(sender As Object, e As EventArgs) Handles mnuColumnOn.Click
        Dim mnuItem As ToolStripMenuItem = sender
        Dim cMenu As ContextMenuStrip = mnuItem.Owner
        Dim thisPic As PictureBox = cMenu.SourceControl
        Dim col As Integer = (thisPic.Location.X - 10) / 55
        For y As Integer = 0 To 4
            picPixel(col, y).BackColor = Color.Red
        Next
        frames(current).UpdateFrameFromPicBoxArray(picPixel)
        UpdateList()
        lstFrames.SelectedIndex = current
        lstFrames.Focus()
    End Sub

    Private Sub mnuColumnOff_Click(sender As Object, e As EventArgs) Handles mnuColumnOff.Click
        Dim mnuItem As ToolStripMenuItem = sender
        Dim cMenu As ContextMenuStrip = mnuItem.Owner
        Dim thisPic As PictureBox = cMenu.SourceControl
        Dim col As Integer = (thisPic.Location.X - 10) / 55
        For y As Integer = 0 To 4
            picPixel(col, y).BackColor = Color.White
        Next
        frames(current).UpdateFrameFromPicBoxArray(picPixel)
        UpdateList()
        lstFrames.SelectedIndex = current
        lstFrames.Focus()
    End Sub

    Private Sub mnuToggleRow_Click(sender As Object, e As EventArgs) Handles mnuToggleRow.Click
        Dim mnuItem As ToolStripMenuItem = sender
        Dim cMenu As ContextMenuStrip = mnuItem.Owner
        Dim thisPic As PictureBox = cMenu.SourceControl
        Dim row As Integer = (thisPic.Location.Y - 10) / 55
        For x As Integer = 0 To 4
            If picPixel(x, row).BackColor = Color.White Then
                picPixel(x, row).BackColor = Color.Red
            Else
                picPixel(x, row).BackColor = Color.White
            End If
        Next
        frames(current).UpdateFrameFromPicBoxArray(picPixel)
        UpdateList()
        lstFrames.SelectedIndex = current
        lstFrames.Focus()
    End Sub

    Private Sub mnuToggleColumn_Click(sender As Object, e As EventArgs) Handles mnuToggleColumn.Click
        Dim mnuItem As ToolStripMenuItem = sender
        Dim cMenu As ContextMenuStrip = mnuItem.Owner
        Dim thisPic As PictureBox = cMenu.SourceControl
        Dim col As Integer = (thisPic.Location.X - 10) / 55
        For y As Integer = 0 To 4
            If picPixel(col, y).BackColor = Color.White Then
                picPixel(col, y).BackColor = Color.Red
            Else
                picPixel(col, y).BackColor = Color.White
            End If
        Next
        frames(current).UpdateFrameFromPicBoxArray(picPixel)
        UpdateList()
        lstFrames.SelectedIndex = current
        lstFrames.Focus()
    End Sub

    Private Sub btnCode_Click(sender As Object, e As EventArgs) Handles btnCode.Click
        frames(current).UpdateFrameFromPicBoxArray(picPixel)
        Dim strCode As String = "from microbit import *" & vbNewLine & vbNewLine
        strCode &= "imgs = [" & vbNewLine
        ' read each frame
        For Each f In frames
            strCode &= vbTab & "Image(" & f.FrameToString() & ")," & vbNewLine
        Next
        strCode = strCode.Substring(0, strCode.LastIndexOf(",")) & vbNewLine
        strCode &= "]" & vbNewLine & "display.show(imgs, delay=" & Trim(Str(numDelay.Value)) & ", loop=True)"
        Dim pre As New PreviewCode()
        pre.txtCodeOut.Text = strCode
        pre.ShowDialog()

    End Sub

    Private Sub btnPreview_Click(sender As Object, e As EventArgs) Handles btnPreview.Click
        frames(current).UpdateFrameFromPicBoxArray(picPixel)
        Dim pre As New PreviewAnimation
        pre.ShowDialog()
    End Sub

    Private Sub btnSave_Click(sender As Object, e As EventArgs) Handles btnSave.Click
        Dim sd As New SaveFileDialog()
        sd.Title = "Save Your Animation"
        sd.Filter = "Animation|*.anim"
        Dim strOut As String = ""
        For Each f In frames
            strOut &= f.FrameToCSV() & vbNewLine
        Next
        If sd.ShowDialog() = DialogResult.OK Then
            File.WriteAllText(sd.FileName, strOut)
        End If
    End Sub

    Private Sub btnLoad_Click(sender As Object, e As EventArgs) Handles btnLoad.Click
        Dim od As New OpenFileDialog()
        od.Title = "Load An Animation"
        od.Filter = "Animation|*.anim"
        If od.ShowDialog() = DialogResult.OK Then
            Dim s() As String = File.ReadAllLines(od.FileName)
            frames.Clear()
            Dim f As AnimationFrame

            For i As Integer = 0 To s.Length - 1
                f = New AnimationFrame()
                f.UpdateFrameFromCSVString(s(i))
                frames.Add(f)
            Next
            frames(0).UpdatePicBoxArrayFromFrame(picPixel)
            lstFrames.SelectedIndex = 0
            UpdateList()

        End If
    End Sub

    Private Sub btnRestart_Click(sender As Object, e As EventArgs) Handles btnRestart.Click
        If MessageBox.Show("Remove all animation frames and start again?", "Are you sure?", MessageBoxButtons.YesNo) = DialogResult.Yes Then

            frames.Clear()
            Dim f As AnimationFrame = New AnimationFrame()
            frames.Add(f)
            UpdateList()
            lstFrames.SelectedIndex = 0


        End If
    End Sub
End Class
